hdu1011----Starship Troopers

Starship Troopers

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 11797    Accepted Submission(s): 3256

Problem Description

You, the leader of Starship Troopers, are sent to destroy a base of the bugs. The base is built underground. It is actually a huge cavern, which consists of many rooms connected with tunnels. Each room is occupied by some bugs, and
their brains hide in some of the rooms. Scientists have just developed a new weapon and want to experiment it on some brains. Your task is to destroy the whole base, and capture as many brains as possible.

To kill all the bugs is always easier than to capture their brains. A map is drawn for you, with all the rooms marked by the amount of bugs inside, and the possibility of containing a brain. The cavern‘s structure is like a tree in such a way that there is
one unique path leading to each room from the entrance. To finish the battle as soon as possible, you do not want to wait for the troopers to clear a room before advancing to the next one, instead you have to leave some troopers at each room passed to fight
all the bugs inside. The troopers never re-enter a room where they have visited before.

A starship trooper can fight against 20 bugs. Since you do not have enough troopers, you can only take some of the rooms and let the nerve gas do the rest of the job. At the mean time, you should maximize the possibility of capturing a brain. To simplify the
problem, just maximize the sum of all the possibilities of containing brains for the taken rooms. Making such a plan is a difficult job. You need the help of a computer.

Input

The input contains several test cases. The first line of each test case contains two integers N (0 < N <= 100) and M (0 <= M <= 100), which are the number of rooms in the cavern and the number of starship troopers you have, respectively.
The following N lines give the description of the rooms. Each line contains two non-negative integers -- the amount of bugs inside and the possibility of containing a brain, respectively. The next N - 1 lines give the description of tunnels. Each tunnel is
described by two integers, which are the indices of the two rooms it connects. Rooms are numbered from 1 and room 1 is the entrance to the cavern.

The last test case is followed by two -1‘s.

Output

For each test case, print on a single line the maximum sum of all the possibilities of containing brains for the taken rooms.

Sample Input

5 10
50 10
40 10
40 20
65 30
70 30
1 2
1 3
2 4
2 5
1 1
20 7
-1 -1

Sample Output

50
7

Author

XU, Chuan

Source

ZJCPC2004

Recommend

JGShining   |   We have carefully selected several similar problems for you:  2955 2415 1059 1712 3033

Statistic | Submit | Discuss
| Note

树形dp, dp[u][i]表示派i个士兵去攻打u这个子树所能得到的最优解

dp[u][i] = max(dp[v][j] + dp[u][i - j])

/*************************************************************************
    > File Name: hdu1011.cpp
    > Author: ALex
    > Mail: [email protected]
    > Created Time: 2015年01月03日 星期六 14时41分19秒
 ************************************************************************/

#include <map>
#include <set>
#include <queue>
#include <stack>
#include <vector>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>

using namespace std;

const int N = 150;
int dp[N][N];
int pro[N];
int bug[N];
int n, m;
vector <int> edge[N];

void dfs(int u, int fa)
{
	int tmp = bug[u] / 20;
	if (bug[u] % 20 && bug[u])
	{
		++tmp;
	}
	for (int i = tmp; i <= m; ++i)
	{
		dp[u][i] = pro[u];
	}
	int size = edge[u].size();
	for (int i = 0; i < size; ++i)
	{
		int v = edge[u][i];
		if (v == fa)
		{
			continue;
		}
		dfs(v, u);
		for (int j = m; j >= tmp; --j) //bug[u] 用来 制服u节点
		{
			for (int k = 1; k <= j - tmp; ++k) //注意k要从1开始,因为每个房间都至少有一个士兵
			{
				dp[u][j] = max(dp[u][j], dp[v][k] + dp[u][j - k]);
			}

		}
	}
}

int main()
{
	int u, v;
	while (~scanf("%d%d", &n, &m))
	{
		if (n == -1 && m == -1)
		{
			break;
		}
		memset (dp, 0, sizeof(dp));
		for (int i = 1; i <= n; ++i)
		{
			edge[i].clear();
			scanf("%d%d", &bug[i], &pro[i]);
		}
		for (int i = 1;  i <= n - 1; ++i)
		{
			scanf("%d%d", &u, &v);
			edge[u].push_back(v);
			edge[v].push_back(u);
		}
		if (m == 0)
		{
			printf("0\n");
			continue;
		}
		dfs(1, -1);
		printf("%d\n", dp[1][m]);
	}
	return 0;
}
时间: 2024-10-06 01:33:39

hdu1011----Starship Troopers的相关文章

HDU-1011 Starship Troopers (树形DP+分组背包)

题目大意:给一棵有根带点权树,并且给出容量.求在不超过容量下的最大权值.前提是选完父节点才能选子节点. 题目分析:树上的分组背包. ps:特判m为0时的情况. 代码如下: # include<iostream> # include<cstdio> # include<vector> # include<cstring> # include<algorithm> using namespace std; const int N=105; const

HDU 1011 Starship Troopers(树形dp+背包)

Starship Troopers Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 13109    Accepted Submission(s): 3562 Problem Description You, the leader of Starship Troopers, are sent to destroy a base of

Starship Troopers

Problem Description You, the leader of Starship Troopers, are sent to destroy a base of the bugs. The base is built underground. It is actually a huge cavern, which consists of many rooms connected with tunnels. Each room is occupied by some bugs, an

HDU 1011 Starship Troopers(树形DP)

Starship Troopers Time Limit : 10000/5000ms (Java/Other)   Memory Limit : 65536/32768K (Java/Other) Total Submission(s) : 62   Accepted Submission(s) : 12 Font: Times New Roman | Verdana | Georgia Font Size: ← → Problem Description You, the leader of

hdu 1011 Starship Troopers(树形DP入门)

Starship Troopers Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 17498    Accepted Submission(s): 4644 Problem Description You, the leader of Starship Troopers, are sent to destroy a base of t

hdu 1011 Starship Troopers (依赖背包 树形dp)

题目: 链接:点击打开链接 题意: n个房间组成一棵树,你有m个战队,从1号房间开始依次clear每个房间,在每个房间需要花费的战队个数是bugs/20,得到的价值是the possibility of capturing a brain,求最大的价值. 算法: 树形dp,有依赖的背包问题.(依次clear每个房间) 思路: 状态转移dp[i][j]表示根结点为i时(房间i)花费j个战队能够得到的最大价值(捕捉到一个brain最大的可能值).递归求出每个根结点处的最大值,最后dp[1][m]就是

hdu 1011 Starship Troopers DP

Starship Troopers Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 11929    Accepted Submission(s): 3295 Problem Description You, the leader of Starship Troopers, are sent to destroy a base of

BNUOJ 5235 Starship Troopers

Starship Troopers Time Limit: 5000ms Memory Limit: 32768KB This problem will be judged on HDU. Original ID: 101164-bit integer IO format: %I64d      Java class name: Main You, the leader of Starship Troopers, are sent to destroy a base of the bugs. T

树形dp/hdu 1011 Starship Troopers

题意 有n个房子,1号为起点房子.每个房子里会消耗一定的士兵来获取一定的价值.现在有m个士兵,求问可以获得的最大价值 注意:走过的房子不能再走 注意2:若要消灭这个房子的bugs,必须全部消灭 分析 典型的树形dp,01背包,因为每个房子里要么全杀死bugs,要么一个不动,只有取或不取两种状态 设f[i][j]表示以i为根节点,消耗j个士兵所能获得的最大价值 则f[i][j]=max(f[son[i]][k] + f[i][j-k]); 答案为f[1][m] Accepted Code 1 /*

Starship Troopers(HDU 1011 树形DP)

题意: 给定n个定点和m个士兵,n个定点最终构成一棵树,每个定点有一定x个bugs和y个value,每20个bug需要消耗一个士兵,不足20也消耗一个,然后最终收获y个value,只有父节点被占领后子节点才有被占领的可能. DP状态转移方程: dp[p][j]=max(dp[p][j],dp[p][j-k]+dp[t][k]); 看的王大神的代码,DFS写的,先从叶子节点开始向上遍历进行动态规划,自己看了dp方程也没写出来.. 1 #include <iostream> 2 #include